-- Panic Tracker by Fluffies
-- EU - Well of Eternity
local addonTitle, addonTable = ...

PTracker = {}
-- main panel
 PTracker.panel = CreateFrame("Frame", "PTracker_Config", UIParent)
 local mainframe = PTracker.panel
 mainframe:Hide()
 mainframe.name = "Panic Tracker"
 InterfaceOptions_AddCategory(mainframe)
-- title
 mainframe.title = mainframe:CreateFontString()
 mainframe.title:SetFont("Fonts\\ARIALN.ttf", 18, "")
 mainframe.title:SetText("|cff00FF00Panic Tracker|r\n|cff999999by |cff00FF99Fluffies|r|cff999999 (EU - Well of Eternity)|r")
 mainframe.title:SetPoint("TOP", mainframe, "TOP", 0, -10)
-- enabled
 mainframe.enabled = CreateFrame("CheckButton", "PTC_Checkbox0", mainframe, "OptionsCheckButtonTemplate")
 _G[mainframe.enabled:GetName().."Text"]:SetText("Enabled")
 mainframe.enabled:SetPoint("TOPLEFT", mainframe, "TOPLEFT", 10, -40)
 mainframe.enabled:SetScript("OnClick", function() 
  PTracker_Saves.enabled = mainframe.enabled:GetChecked() and true or false
  addonTable:OptionChanged()
 end)
-- locked (hide anchor)
 mainframe.locked = CreateFrame("CheckButton", "PTC_Checkbox1", mainframe, "OptionsCheckButtonTemplate")
 _G[mainframe.locked:GetName().."Text"]:SetText("Locked")
 mainframe.locked:SetPoint("TOPLEFT", mainframe, "TOPLEFT", 10, -60)
 mainframe.locked:SetScript("OnClick", function() 
  PTracker_Saves.locked = mainframe.locked:GetChecked()
  addonTable:OptionChanged()
 end)
-- hide out of combat
 mainframe.hideoutofcombat = CreateFrame("CheckButton", "PTC_Checkbox2", mainframe, "OptionsCheckButtonTemplate")
 _G[mainframe.hideoutofcombat:GetName().."Text"]:SetText("Hide out of combat")
 mainframe.hideoutofcombat:SetPoint("TOPLEFT", mainframe, "TOPLEFT", 10, -80)
 mainframe.hideoutofcombat:SetScript("OnClick", function() 
  PTracker_Saves.hideoutofcombat = mainframe.hideoutofcombat:GetChecked()
  addonTable:OptionChanged()
 end)
-- bars orientation
 mainframe.orientation = CreateFrame("CheckButton", "PTC_Checkbox3", mainframe, "OptionsCheckButtonTemplate")
 _G[mainframe.orientation:GetName().."Text"]:SetText("Bars orientation")
 mainframe.orientation:SetPoint("TOPLEFT", mainframe, "TOPLEFT", 10, -100)
 mainframe.orientation:SetScript("OnClick", function() 
  PTracker_Saves.orientation = mainframe.orientation:GetChecked()
  addonTable:OptionChanged()
 end)
-- range
 mainframe.rangelabel = mainframe:CreateFontString()
 mainframe.rangelabel:SetFont("Fonts\\ARIALN.ttf", 13, "")
 mainframe.rangelabel:SetText("Time Range (in seconds): ")
 mainframe.rangelabel:SetPoint("TOPLEFT", mainframe, "TOPLEFT", 10, -130)
 mainframe.range = CreateFrame("Slider", "PTC_Slider0", mainframe, "OptionsSliderTemplate")
 mainframe.range:SetPoint("LEFT", mainframe.rangelabel, "RIGHT", 5, 0)
 mainframe.range:SetMinMaxValues(1, 3)
 _G[mainframe.range:GetName() .. 'Low']:SetText('1')
 _G[mainframe.range:GetName() .. 'High']:SetText('3')
 mainframe.range:SetValueStep(1)
 mainframe.range:SetScript("OnValueChanged", function(self, value) 
   local v = math.floor(value)
   mainframe.range:SetValue(v)
   PTracker_Saves.range = v
  end)
-- length
 mainframe.lengthlabel = mainframe:CreateFontString()
 mainframe.lengthlabel:SetFont("Fonts\\ARIALN.ttf", 13, "")
 mainframe.lengthlabel:SetText("Bars Length: ")
 mainframe.lengthlabel:SetPoint("TOPLEFT", mainframe, "TOPLEFT", 10, -160)
 mainframe.length = CreateFrame("Slider", "PTC_Slider1", mainframe, "OptionsSliderTemplate")
 mainframe.length:SetPoint("LEFT", mainframe.lengthlabel, "RIGHT", 5, 0)
 mainframe.length:SetMinMaxValues(20, 500)
 _G[mainframe.length:GetName() .. 'Low']:SetText('20')
 _G[mainframe.length:GetName() .. 'High']:SetText('500')
 mainframe.length:SetValueStep(1)
 mainframe.length:SetScript("OnValueChanged", function(self, value) 
   local v = math.floor(value)
   mainframe.length:SetValue(v)
   PTracker_Saves.length = v
   mainframe.lengthedit:SetText(PTracker_Saves.length)
   addonTable:OptionChanged()
  end)
 mainframe.lengthedit = CreateFrame("EditBox", "PTC_EditBox0", mainframe, "InputBoxTemplate")
 mainframe.lengthedit:SetPoint("LEFT", mainframe.length, "RIGHT", 10, 0)
 mainframe.lengthedit:SetSize(35,15)
 mainframe.lengthedit:SetAutoFocus(false)
 mainframe.lengthedit:SetScript("OnTextChanged", function(self, userInput) 
   if not userInput then return end
   local s = mainframe.lengthedit:GetText()
   string.gsub(s, "%D", "")
   mainframe.lengthedit:SetText(s)
  end)
 mainframe.lengthedit:SetScript("OnEnterPressed", function(self)
   self:ClearFocus()
  end)
 mainframe.lengthedit:SetScript("OnEditFocusLost", function(self)
   local s = self:GetText()
   mainframe.length:SetValue(tonumber(s))
   PTracker_Saves.length = tonumber(s)
   addonTable:OptionChanged()
  end)
-- thickness
 mainframe.thicknesslabel = mainframe:CreateFontString()
 mainframe.thicknesslabel:SetFont("Fonts\\ARIALN.ttf", 13, "")
 mainframe.thicknesslabel:SetText("Bars Thickness: ")
 mainframe.thicknesslabel:SetPoint("TOPLEFT", mainframe, "TOPLEFT", 10, -190)
 mainframe.thickness = CreateFrame("Slider", "PTC_Slider2", mainframe, "OptionsSliderTemplate")
 mainframe.thickness:SetPoint("LEFT", mainframe.thicknesslabel, "RIGHT", 5, 0)
 mainframe.thickness:SetMinMaxValues(10, 150)
 _G[mainframe.thickness:GetName() .. 'Low']:SetText('10')
 _G[mainframe.thickness:GetName() .. 'High']:SetText('150')
 mainframe.thickness:SetValueStep(1)
 mainframe.thickness:SetScript("OnValueChanged", function(self, value) 
   local v = math.floor(value)
   mainframe.thickness:SetValue(v)
   PTracker_Saves.thickness = v
   mainframe.thicknessedit:SetText(PTracker_Saves.thickness)
   addonTable:OptionChanged()
  end)
 mainframe.thicknessedit = CreateFrame("EditBox", "PTC_EditBox1", mainframe, "InputBoxTemplate")
 mainframe.thicknessedit:SetPoint("LEFT", mainframe.thickness, "RIGHT", 10, 0)
 mainframe.thicknessedit:SetSize(35,15)
 mainframe.thicknessedit:SetAutoFocus(false)
 mainframe.thicknessedit:SetScript("OnTextChanged", function(self, userInput) 
   if not userInput then return end
   local s = mainframe.thicknessedit:GetText()
   string.gsub(s, "%D", "")
   mainframe.thicknessedit:SetText(s)
  end)
 mainframe.thicknessedit:SetScript("OnEnterPressed", function(self)
   self:ClearFocus()
  end)
 mainframe.thicknessedit:SetScript("OnEditFocusLost", function(self)
   local s = self:GetText()
   mainframe.thickness:SetValue(tonumber(s))
   PTracker_Saves.thickness = tonumber(s)
   addonTable:OptionChanged()
  end)

--[[
-- damage options panel
 PTracker.dpspanel = CreateFrame("Frame", "PTracker_ConfigDPS", UIParent)
 PTracker.dpspanel.name = "Damage Bar"
 PTracker.dpspanel.parent = mainframe.name
 InterfaceOptions_AddCategory(PTracker.dpspanel)
-- healing options panel
 PTracker.hpspanel = CreateFrame("Frame", "PTracker_ConfigHPS", UIParent)
 PTracker.hpspanel.name = "Heals Bar"
 PTracker.hpspanel.parent = mainframe.name
 InterfaceOptions_AddCategory(PTracker.hpspanel)

local function generateconfigframe(f, arg)
 -- enabled checkbox
 f.enabled = CreateFrame("CheckButton", "PTC_Checkbox0"..arg, f, "OptionsCheckButtonTemplate")
 _G[f.enabled:GetName().."Text"]:SetText("Enabled")
 f.enabled:SetPoint("TOPLEFT", f, "TOPLEFT", 10, -10)
 f.enabled:SetScript("OnClick", function() PTracker_Saves[arg].enabled = f.enabled:GetChecked() end)
end

 generateconfigframe(PTracker.dpspanel, "dps")
 generateconfigframe(PTracker.hpspanel, "hps")

]]

function addonTable:SetupConfigFrame()
 mainframe.enabled:SetChecked(PTracker_Saves.enabled)
 mainframe.locked:SetChecked(PTracker_Saves.locked)
 mainframe.orientation:SetChecked(PTracker_Saves.orientation)
 mainframe.hideoutofcombat:SetChecked(PTracker_Saves.hideoutofcombat)
 mainframe.range:SetValue(PTracker_Saves.range)
 mainframe.length:SetValue(PTracker_Saves.length)
 mainframe.lengthedit:SetText(PTracker_Saves.length)
 mainframe.thickness:SetValue(PTracker_Saves.thickness)
 mainframe.thicknessedit:SetText(PTracker_Saves.thickness)
end